co        = require("co")
pathToReg = require("path-to-regexp")
compose   = require("./util/compose")
parseDates = require("./util/parseDates")
Request   = require("./request")
Response  = require("./response")

if process.browser
	hijack = require("./hijackBrowser")
	chain = []
else
	http = require("http")
	chain = [require("./util/serverResponse")]


class Application
	constructor: ->
		return new Application() unless this instanceof Application
		@middleware = []

	listen: ->
		if process.browser
			hijack.onChange(@callback())
			hijack.listen()
		else
			server = http.createServer(@callback())
			server.listen.apply(server, arguments)

	callback: ->
		fn = co.wrap(compose(chain.concat(@middleware)))
		(req, res)->
			fn.call({}, new Request(req), new Response(res)).catch((err)-> throw err)

	use: (middlewares...)->
		@middleware = @middleware.concat(middlewares)
		return this

	for method in ["options", "head", "get", "put", "post", "delete"]
		@::[method] = do (method)-> (path, middlewares...)->
			keys = []
			path = pathToReg(path, keys)
			method = method.toUpperCase()
			middlewares = compose(middlewares)

			@use((req, res, next)->
				if req.method is method and match = req.url.pathname.match(path.regex)
					req.params = {}
					req.params[name] = match[i + 1] for { name }, i in keys
					yield middlewares.call(@, req, res, next)
				else yield next
			)

			return this


module.exports = Application
